import co.*;
import com.evelopers.unimod.log.Logger;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import com.evelopers.unimod.runtime.logger.SimpleLogger;
import ep.ControlPane;

/**
 *  .    
 * ,  ,   .
 */
public class Test {
    /**
     * ,    .
     *
     * @param args   .
     */
    public static void main(String[] args) {
        Test a = new Test();
        a.run();
    }

    /**
     *       ,
     *     .
     */
    private class ExitListener
            extends AbstractEventProcessorListener {
        private boolean done;

        public void stateMachineCameToFinalState(
                StateMachineContext context, StateMachinePath path,
                StateMachineConfig config) {
            if (path.isRoot()) done = true;
        }
    }

    /**
     *    ,  ,
     *   .
     */
    void run() {
        ModelEngine me;
        try {
            ControlledObjectsManager b
                = new ControlledObjectsManager() {
                //   .
                Display o1 = new Display();
                CoinMechanism o2 = new CoinMechanism();
                DrinkMakingDevice o3 = new DrinkMakingDevice();
                PourOutDevice o4 = new PourOutDevice();
                ColdStore o5 = new ColdStore();

                public void init(ModelEngine engine) {
                }

                public void dispose() {
                }

                public ControlledObject getControlledObject(
                        String coName) {
                    if (coName.equals("o1")) return o1;
                    if (coName.equals("o2")) return o2;
                    if (coName.equals("o3")) return o3;
                    if (coName.equals("o4")) return o4;
                    if (coName.equals("o5")) return o5;
                    return null;
                }
            };
            me = ModelEngine.createStandAlone(new QueuedHandler(),
                    new Model1EventProcessor(), b,
                    new EventProvidersManager() {
                        //   .
                        ControlPane p1 = new ControlPane();

                        public void init(ModelEngine engine) {
                            p1.init(engine);
                        }

                        public void dispose() {
                            p1.dispose();
                        }

                        public EventProvider getEventProvider(
                            String epName) {
                            if (epName.equals("p1")) return p1;
                            return null;
                        }
                    });
            me.getEventProcessor().addEventProcessorListener(
                    new SimpleLogger(Logger.CONSOLE));
            ExitListener l1 = new ExitListener();
            me.getEventProcessor().addEventProcessorListener(l1);
            me.start();

            while (!l1.done) {
                Thread.sleep(10);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}