package co;

import co.ui.ControlPaneView;
import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import common.Parameters;

/**
 *     ,   
 *    .
 */
public class CoinMechanism implements ControlledObject {
    private int prepayment;

    /**
     * @unimod.action.descr      
     */
    public void z1(StateMachineContext context) {
        int coinType = ((Integer) context.getEventContext()
            .getParameter(Parameters.COIN_TYPE)).intValue();
        context.getEventContext().setParameter(
                Parameters.PREPAYMENT, new Integer(prepayment));
        prepayment += coinType;
        context.getApplicationContext().setParameter(
                Parameters.PREPAYMENT, new Integer(prepayment));
        System.out.println(Parameters.getMessage(
            "Logger.CoinMechanism.z1", coinType));
    }

    /**
     * @unimod.action.descr    
     */
    public void z2(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.CoinMechanism.z2"));
        ControlPaneView.getVm().drawCoins(1);
    }

    /**
     * @unimod.action.descr     
     */
    public void z3(StateMachineContext context) {
        int drinkPrice = Integer.parseInt(Parameters.getMessage(
            "ControlPaneView.Drinks.Price."
            + context.getEventContext().getParameter(
                Parameters.REQUESTED_DRINK)));
        context.getEventContext().setParameter(
                Parameters.PREPAYMENT, new Integer(prepayment));
        prepayment -= drinkPrice;
        context.getApplicationContext().setParameter(
                Parameters.PREPAYMENT, new Integer(prepayment));
        System.out.println(Parameters.getMessage(
            "Logger.CoinMechanism.z3", drinkPrice));
    }

    /**
     * @unimod.action.descr   
     */
    public void z4(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.CoinMechanism.z4"));
        int change = prepayment;
        int coins = (change / 5) + ((change % 5) / 2)
                + ((change % 5) % 2);
        context.getEventContext().setParameter(Parameters.PREPAYMENT,
                new Integer(prepayment));
        prepayment = 0;
        context.getApplicationContext().setParameter(
                Parameters.PREPAYMENT, new Integer(prepayment));
        ControlPaneView.getVm().drawCoins(coins);
    }

    /**
     * @unimod.action.descr  
     *   
     */
    public boolean x1(StateMachineContext context) {
        int coinType = ((Integer) context.getEventContext()
            .getParameter(Parameters.COIN_TYPE)).intValue();
        if (coinType == Parameters.FALSE_COIN) {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x1.false"));
            return false;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x1.true"));
            return true;
        }
    }

    /**
     * @unimod.action.descr  
     *    
     */
    public boolean x2(StateMachineContext context) {
        int drinkPrice = Integer.parseInt(Parameters.getMessage(
            "ControlPaneView.Drinks.Price."
            + context.getEventContext().getParameter(
                Parameters.REQUESTED_DRINK)));
        Integer iSum = (Integer) context.getEventContext()
            .getParameter(Parameters.PREPAYMENT);
        int sum;
        if (iSum == null) sum = prepayment;
        else sum = iSum.intValue();
        if (drinkPrice > sum) {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x2.false"));
            return false;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x2.true"));
            return true;
        }
    }

    /**
     * @unimod.action.descr  
     */
    public boolean x3(StateMachineContext context) {
        Integer iSum = (Integer) context.getEventContext()
            .getParameter(Parameters.PREPAYMENT);
        int sum;
        if (iSum == null) sum = prepayment;
        else sum = iSum.intValue();
        if (sum == 0) {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x3.false"));
            return false;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x3.true"));
            return true;
        }
    }

    /**
     * @unimod.action.descr    
     *   
     */
    public boolean x4(StateMachineContext context) {
        Integer iSum = (Integer) context.getEventContext()
            .getParameter(Parameters.PREPAYMENT);
        int sum;
        if (iSum == null) sum = prepayment;
        else sum = iSum.intValue();
        int maxPrice = 0;
        for (int j = 0; j < Parameters.NUM_DRINKS; j++) {
            maxPrice = Math.max(maxPrice,
                Integer.parseInt(Parameters.getMessage(
                    "ControlPaneView.Drinks.Price." + j)));
        }
        if (sum < maxPrice) {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x4.false"));
            return false;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.CoinMechanism.x4.true"));
            return true;
        }
    }
}