package co;

import co.ui.ControlPaneView;
import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import common.Parameters;

import java.util.*;
import java.util.Timer;

/**
 *       .
 */
public class Display implements ControlledObject {
    private static String defaultMessage = Parameters.getMessage(
        "Message.BuyDrink");
    private Timer timer;

    private void showMessage(String msg) {
        int delay = Integer.parseInt(
            Parameters.getParameter("timer-delay"));
        if (timer != null) {
            timer.cancel();
        }
        ControlPaneView.getVm().drawMessage(msg);
        timer = new Timer(true);
        timer.schedule(new TimerTask() {
            public void run() {
                ControlPaneView.getVm().drawMessage(defaultMessage);
                ControlPaneView.getVm().drawCoins(0);
                ControlPaneView.getVm().drawCan(false);
            }
        }, delay);
    }

    /**
     * @unimod.action.descr  
     */
    public void z1(StateMachineContext context) {
        System.out.println(Parameters.getMessage("Logger.Display.z0"));
    }

    /**
     * @unimod.action.descr   
     *  
     */
    public void z2(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.FalseCoin"));
        System.out.println(Parameters.getMessage("Logger.Display.z2"));
    }

    /**
     * @unimod.action.descr   
     *    
     */
    public void z3(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.NeedMoreMoney"));
        System.out.println(Parameters.getMessage("Logger.Display.z3"));
    }

    /**
     * @unimod.action.descr    
     */
    public void z4(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.TakeMoney"));
        System.out.println(Parameters.getMessage("Logger.Display.z4"));
    }

    /**
     * @unimod.action.descr    
     */
    public void z5(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.PleaseWait"));
        timer.cancel();
        System.out.println(Parameters.getMessage("Logger.Display.z5"));
    }

    /**
     * @unimod.action.descr  
     *   
     */
    public void z6(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.Thanks"));
        System.out.println(Parameters.getMessage("Logger.Display.z6"));
    }

    /**
     * @unimod.action.descr   
     *  
     */
    public void z7(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.NoDrinkAvailable"));
        System.out.println(Parameters.getMessage("Logger.Display.z7"));
    }

    /**
     * @unimod.action.descr    
     *    
     */
    public void z8(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.EnoughMoney"));
        System.out.println(Parameters.getMessage("Logger.Display.z8"));
    }

    /**
     * @unimod.action.descr   
     *    
     */
    public void z9(StateMachineContext context) {
        showMessage(Parameters.getMessage("Message.TurnOff"));
        System.out.println(Parameters.getMessage("Logger.Display.z9"));
    }

    /**
     * @unimod.action.descr   
     */
    public void z10(StateMachineContext context) {
        int currPrepayment = ((Integer) context.getApplicationContext()
            .getParameter(Parameters.PREPAYMENT)).intValue();
        ControlPaneView.getVm().drawPrepayment(currPrepayment);
        System.out.println(
            Parameters.getMessage("Logger.Display.z10"));
    }

    /**
     * @unimod.action.descr   
     *   
     */
    public void z11(StateMachineContext context) {
        System.out.println(
            Parameters.getMessage("Logger.Display.z11"));
    }

    /**
     * @unimod.action.descr   
     *   
     */
    public void z12(StateMachineContext context) {
        int drink = ((Integer) context.getApplicationContext()
            .getParameter(Parameters.REQUESTED_DRINK)).intValue();
        ControlPaneView.getVm().drawTurnedOffIndicator(drink);
        System.out.println(Parameters.getMessage("Logger.Display.z12",
            Parameters.getMessage("ControlPaneView.Drinks." + drink)));
    }

    /**
     * @unimod.action.descr  
     */
    public void z13(StateMachineContext context) {
        System.out.println(
            Parameters.getMessage("Logger.Display.z13"));
    }
}