package co;

import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import common.Parameters;
import co.ui.ControlPaneView;

import java.util.TimerTask;
import java.util.Timer;

/**
 *    .  
 *       ,
 *      
 * .     
 *      .
 */
public class DrinkMakingDevice implements ControlledObject {
    private int[] drinksQuantity;
    private double CO2Volume;

    /**
     * @unimod.action.descr    
     */
    public void z0(StateMachineContext context) {
        int initialQuantity = Integer.parseInt(Parameters
            .getParameter("initial-drink-quantity"));
        drinksQuantity = new int[]{initialQuantity,
                                   initialQuantity, initialQuantity,
                                   initialQuantity, initialQuantity};
        CO2Volume = Double.parseDouble(Parameters.getParameter(
            "initial-co2-volume"));
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z0"));
    }

    /**
     * @unimod.action.descr  200  
     *   
     */
    public void z1(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z1"));
    }

    /**
     * @unimod.action.descr   
     *    
     */
    public void z2(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z2"));
    }

    /**
     * @unimod.action.descr  
     *   
     */
    public void z3(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z3"));
        final Integer drinkNumber = (Integer) context.getEventContext()
            .getParameter(Parameters.REQUESTED_DRINK);
        int delay = Integer.parseInt(Parameters.getParameter(
            "timer-delay"));
        (new Timer(true)).schedule(new TimerTask() {
            public void run() {
                ControlPaneView.getVm().fireEvent(ep.ControlPane.E5,
                    Parameters.REQUESTED_DRINK, drinkNumber);
            }
        }, delay);
    }

    /**
     * @unimod.action.descr  
     *   
     */
    public void z4(StateMachineContext context) {
        int drinkNumber = ((Integer) context.getApplicationContext()
            .getParameter(Parameters.REQUESTED_DRINK)).intValue();
        drinksQuantity[drinkNumber]--;
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z4",
            Parameters.getMessage("ControlPaneView.Drinks."
                + drinkNumber)));
    }

    /**
     * @unimod.action.descr  
     *   
     */
    public void z5(StateMachineContext context) {
        CO2Volume -= 1.6;
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z5"));
    }

    /**
     * @unimod.action.descr    
     */
    public void z6(StateMachineContext context) {
        System.out.println(Parameters.getMessage(
            "Logger.DrinkMakingDevice.z6"));

        int delay = Integer.parseInt(
            Parameters.getParameter("timer-delay"));
        if (delay > 200) delay -= 200;
        Timer timer = new Timer(true);
        timer.schedule(new TimerTask() {
            public void run() {
                ControlPaneView.getVm().fireEvent(ep.ControlPane.E6);
            }
        }, delay);
    }

    /**
     * @unimod.action.descr    
     */
    public boolean x1(StateMachineContext context) {
        int f = ((Integer) context.getApplicationContext()
            .getParameter(Parameters.REQUESTED_DRINK)).intValue();
        if (drinksQuantity[f] > 0) {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x1.false",
                Parameters.getMessage("ControlPaneView.Drinks." + f)));
            return false;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x1.true",
                Parameters.getMessage("ControlPaneView.Drinks." + f)));
            return true;
        }
    }

    /**
     * @unimod.action.descr    
     */
    public boolean x2(StateMachineContext context) {
        int drinksAvail = 0;
        for (int i = 0; i < Parameters.NUM_DRINKS; i++) {
            drinksAvail += drinksQuantity[i];
        }
        if (drinksAvail == 0) {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x2.true"));
            return true;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x2.false"));
            return false;
        }
    }

    /**
     * @unimod.action.descr    
     */
    public boolean x3(StateMachineContext context) {
        if (CO2Volume <= 0) {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x3.true"));
            return true;
        } else {
            System.out.println(Parameters.getMessage(
                "Logger.DrinkMakingDevice.x3.false"));
            return false;
        }
    }
}