/*
 * Developed by eVelopers Corporation
 *
 * Copyright (c) 1999-2002 eVelopers Corporation. All rights reserved.
 * This software is the confidential and proprietary information of
 * eVelopers Corporation. You shall not disclose such Confidential
 * Information and shall use it only in accordance with the terms of
 * the license agreement you entered into with eVelopers.
 *
 * $Date: 7/10/2003 3:50:50 PM$
 *
 */
package com.evelopers.common.exception;

/**
 * Component throws this exception in case of unrecovered situation from the component
 * point of view. Component container depending of it's own logic may interpret
 * this exception either as system or as logic. Also container may try to
 * restore component state.
 *
 * @author kex
 * @version $Revision: 4$
 * @see com.evelopers.common.exception.CommonException
 */
public class SystemException extends CommonException {

    /**
     * @param message error message
     * @see CommonException#CommonException(String)
     */
    public SystemException(String message) {
        super(message);
    }

    /**
     * @param e original exception
     * @see CommonException#CommonException(Throwable)
     */
    public SystemException(Throwable e) {
        super(e);
    }

    /**
     * @param e       original exception
     * @param message error message
     * @see CommonException#CommonException(Throwable, String)
     */
    public SystemException(Throwable e, String message) {
        super(e, message);
    }

}


/*--- ///:~ ---*/
