package common;

import javax.swing.*;
import java.awt.*;
import java.text.MessageFormat;
import java.util.*;

/**
 *  ,     
 *     properties-.
 */
public class Parameters {
    private static ResourceBundle vmConfig = loadBundle("vm-config");
    private static ResourceBundle vmBundle = loadBundle(
        vmConfig.getString("locale"));
    private static Map pictureCache = new HashMap();

    /**
     * ,      (drag-and-drop).
     */
    public final static Cursor COIN_CURSOR
            = Toolkit.getDefaultToolkit().createCustomCursor(
            Parameters.getImageIcon("coin-drag").getImage(),
            new Point(16, 16), "");

    /**
     *   .
     */
    public final static int NUM_DRINKS = 5;

    /**
     *   .
     */
    public final static int NUM_COINS = 4;

    /**
     *   .
     */
    public final static int FALSE_COIN = -1;

    /**
     *   " ".
     */
    public static final String REQUESTED_DRINK = "REQUESTED_DRINK";

    /**
     *   "  ".
     */
    public static final String COIN_TYPE = "COIN_TYPE";

    /**
     *   " ".
     */
    public static final String PREPAYMENT = "PREPAYMENT";

    /**
     *  ,   
     *   .
     */
    public static final int RUN_MODE_FRAME = 0;

    /**
     *  ,     .
     */
    public static final int RUN_MODE_APPLET = 1;

    /**
     *    :    
     *  .
     */
    public static int runningMode = RUN_MODE_FRAME;

    private static ResourceBundle loadBundle(String name) {
        ResourceBundle bundle = null;
        try {
            bundle = ResourceBundle.getBundle(name);
        } catch (MissingResourceException e) {
            try {
                bundle = ResourceBundle.getBundle(name, Locale.US);
            } catch (MissingResourceException ex) {
                System.out.println("Configuration file \"" + name
                    + ".properties\" not found");
                System.exit(1);
            }
        }
        return bundle;
    }

    /**
     *   .
     *
     * @param key   *.properties-.
     * @return  .
     */
    public static String getMessage(String key) {
        return vmBundle.getString(key);
    }

    /**
     *      ,
     *    .
     *
     * @param key   *.properties-.
     * @param arg  .
     * @return   .
     */
    public static String getMessage(String key, int arg) {
        return MessageFormat.format(vmBundle.getString(key),
            new Object[]{new Integer(arg)});
    }

    /**
     *      ,
     *  .
     *
     * @param key   *.properties-.
     * @param arg  .
     * @return   .
     */
    public static String getMessage(String key, Object arg) {
        return MessageFormat.format(vmBundle.getString(key),
            new Object[]{arg});
    }

    /**
     *   .
     *
     * @param key   *.properties-.
     * @return  .
     */
    public static String getParameter(String key) {
        return vmConfig.getString(key);
    }

    /**
     *  .
     *
     * @param key   *.properties- (   ).
     * @return  .
     */
    public static ImageIcon getImageIcon(String key) {
        ImageIcon img = (ImageIcon) pictureCache.get(key);
        if (img == null) {
            String imgFileName = getParameter(key);
            img = new ImageIcon(
                Parameters.class.getResource(imgFileName));
            pictureCache.put(key, img);
        }
        return img;
    }
}